package eu.dnetlib.validatorapi.processors;

import eu.dnetlib.validatorapi.entities.SummaryResult;
import eu.dnetlib.validatorapi.repositories.SummaryValidationJobRepository;
import eu.dnetlib.validatorapi.repositories.ValidationResultRepository;
import org.apache.camel.Exchange;
import org.apache.camel.Processor;

import java.util.List;

public class SummaryValidationJobProcessor implements Processor {

    private final ValidationResultRepository validationResultRepository;
    private final SummaryValidationJobRepository summaryValidationJobRepository;
    int validation_job_id;

    public SummaryValidationJobProcessor(ValidationResultRepository validationResultRepository,
                                  SummaryValidationJobRepository summaryValidationJobRepository,
                                         int validation_job_id){
        this.validationResultRepository = validationResultRepository;
        this.summaryValidationJobRepository = summaryValidationJobRepository;
        this.validation_job_id = validation_job_id;
    }

    @Override
    public void process(Exchange exchange) throws Exception {
        List<SummaryResult> summaryResults  = validationResultRepository.getFullSummaryResult
                (validation_job_id);


        System.out.println("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
        System.out.println("VALIDATION JOB ID " + (Integer) exchange.getIn().getHeader("validationId"));
        System.out.println("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");

        for(SummaryResult sr: summaryResults) {
            sr.validationJobId = validation_job_id;
            sr.validationJobId = validation_job_id;
            summaryValidationJobRepository.save(sr);
        }
    }
}
